<?php

class OracleManager
{
    public function updateCommand($version)
    {
        if ($version > '1.0-2') {
            return false;
        }
        $this->checkOracleHealth();
        $this->checkOracleHealthWithoutThreshold();
    }

    public function checkOracleHealth()
    {
        $command_id = get_command_id_by_name("system-model-check-oracle-health");

        $sql = "
            SELECT
            ns.service_id,
            nc.command_id,
            group_concat(ncp.parameter) AS parameter
            FROM nagios_services AS ns
            JOIN nagios_commands AS nc ON nc.command_id = ns.check_command
            JOIN nagios_services_check_command_parameters AS ncp ON ncp.service_id = ns.service_id
            WHERE nc.command_id={$command_id}
            GROUP BY ns.service_id,
            nc.command_id;
        ";
        $services = do_query($sql, DBOPCFG, OPDB_FETCH_ASSOC)->fetchAll();

        array_walk($services, function (&$service) {
            $service['parameter'] = explode(",", $service['parameter']);
        });

        $sql = 'UPDATE nagios_commands SET command_line = REPLACE(command_line,"\'","") WHERE command_id = '.$command_id;

        do_query($sql, DBOPCFG);

        $configManager = new ConfigManager();

        foreach ($services as $service) {
            $sql = 'DELETE FROM nagios_services_check_command_parameters WHERE service_id = ' . $service['service_id'];
            do_query($sql, DBOPCFG);

            $configManager->addServiceCheckParameter($service['service_id'], "'".$service['parameter'][0]."'");
            $configManager->addServiceCheckParameter($service['service_id'], $service['parameter'][1]);
            $configManager->addServiceCheckParameter($service['service_id'], $service['parameter'][2]);
            $configManager->addServiceCheckParameter($service['service_id'], $service['parameter'][3]);
            $configManager->addServiceCheckParameter($service['service_id'], $service['parameter'][4]);
            $configManager->addServiceCheckParameter($service['service_id'], $service['parameter'][5]);
        }
    }

    public function checkOracleHealthWithoutThreshold()
    {
        $command_id = get_command_id_by_name("system-model-check-oracle-health-without-threshold");

        $sql = "
            SELECT
            ns.service_id,
            nc.command_id,
            group_concat(ncp.parameter) AS parameter
            FROM nagios_services AS ns
            JOIN nagios_commands AS nc ON nc.command_id = ns.check_command
            JOIN nagios_services_check_command_parameters AS ncp ON ncp.service_id = ns.service_id
            WHERE nc.command_id={$command_id}
            GROUP BY ns.service_id,
            nc.command_id;
        ";
        $services = do_query($sql, DBOPCFG, OPDB_FETCH_ASSOC)->fetchAll();

        array_walk($services, function (&$service) {
            $service['parameter'] = explode(",", $service['parameter']);
        });

        $sql = 'UPDATE nagios_commands SET command_line = REPLACE(command_line,"\'","") WHERE command_id = '.$command_id;

        do_query($sql, DBOPCFG);

        $configManager = new ConfigManager();

        foreach ($services as $service) {
            $sql = 'DELETE FROM nagios_services_check_command_parameters WHERE service_id = ' . $service['service_id'];
            do_query($sql, DBOPCFG);

            $configManager->addServiceCheckParameter($service['service_id'], "'".$service['parameter'][0]."'");
            $configManager->addServiceCheckParameter($service['service_id'], $service['parameter'][1]);
            $configManager->addServiceCheckParameter($service['service_id'], $service['parameter'][2]);
            $configManager->addServiceCheckParameter($service['service_id'], $service['parameter'][3]);
        }
    }
}
